/*
 * Filename: mk_buildlevel.cmd
 *   Author: JAN-ERIK
 *  Created: Sun Aug 17 2014
 *  Purpose:
 *  Changes:
 */

/*
 @#<Vendor>:<Revision>#@##1## DD.MM.YY hh:mm:ss      <BuildHost>:<ASDFeatureID>:<LanguageCode>:<CountryCode>:<Build>:<Unknown>:<FixPackVer>@@<Description>
 */
build_version = ''
build_cpu = ''
build_fixpak = ''
build_feature = ''
IF ARG() > 0 THEN
DO
   IF LENGTH( STRIP( ARG(1) ) ) > 0 THEN
   DO
      IF STREAM( ARG(1), 'C', 'QUERY EXISTS' ) <> '' THEN
      DO
         f_size = STREAM( ARG(1), 'C', 'QUERY SIZE' )
         IF f_size > 10 THEN
         DO
            newln = D2C(13)||D2C(10)
            input = CHARIN( ARG(1), 1, f_size )
            CALL STREAM ARG(1), 'C', 'CLOSE'
            PARSE VALUE input WITH .'VER_MAJOR'build_major(newln).
            PARSE VALUE input WITH .'VER_MINOR'build_minor(newln).
            PARSE VALUE input WITH .'VER_REVISION'build_revision(newln).
            PARSE VALUE input WITH .'VER_BUILD'build_build(newln).
            PARSE VALUE input WITH .'APP_DATE'.'"'build_date'"'(newln).
            PARSE VALUE input WITH .'APP_VENDOR'.'"'build_vendor'"'(newln).
            PARSE VALUE input WITH .'APP_EMAIL'.'"'build_email'"'(newln).
            PARSE VALUE input WITH .'APP_HOMEPAGE'.'"'build_homepage'"'(newln).
            PARSE VALUE input WITH .'APP_NAME'.'"'build_name'"'(newln).
            PARSE VALUE input WITH .'APP_DESCRIPTION'.'"'build_description'"'(newln).
         END
         PARSE VALUE STREAM( ARG(1), 'C', 'QUERY DATETIME' ) WITH mo'-'dd'-'yy hh':'mi':'ss
      END
   END
END

IF \DATATYPE( yy, 'W' ) THEN
   PARSE VALUE DATE( 'O' ) TIME() WITH yy'/'dd'/'mo' 'hh':'mi':'ss
build_major = STRIP( build_major )
DO WHILE \DATATYPE( build_major, 'W' )
   CALL CHAROUT , "Application Major version? "
   PARSE PULL build_major
END

build_minor = STRIP( build_minor )
DO WHILE \DATATYPE( build_minor, 'W' )
   CALL CHAROUT , "Application Minor version? "
   PARSE PULL build_minor
END
build_revision = STRIP( build_revision )
DO WHILE \DATATYPE( build_revision, 'W' )
   CALL CHAROUT , "Application revision version? "
   PARSE PULL build_revision
END
build_build = STRIP( build_build )
DO WHILE \DATATYPE( build_build, 'N' )
   CALL CHAROUT , "Application build version? "
   PARSE PULL build_build
END
build_vendor = STRIP( build_vendor )
DO WHILE build_vendor = 'BUILD_VENDOR'
   CALL CHAROUT , "Application vendor? "
   PARSE PULL build_vendor
END

build_email = STRIP( build_email )
DO WHILE build_email = 'BUILD_EMAIL'
   CALL CHAROUT , "E-mail to application vendor? "
   PARSE PULL build_email
END

build_homepage = STRIP( build_homepage )
DO WHILE build_homepage = 'BUILD_HOMEPAGE'
   CALL CHAROUT , "Homepage of application vendor? "
   PARSE PULL build_homepage
END

build_name = STRIP( build_name )
DO WHILE build_name = 'BUILD_NAME'
   CALL CHAROUT , "Name of Application? "
   PARSE PULL build_name
END

build_description = STRIP( build_description )
DO WHILE build_description = 'BUILD_DESCRIPTION'
   CALL CHAROUT , "Short description of application? "
   PARSE PULL build_description
END

IF DATATYPE( yy, 'W' ) THEN
   build_date = '20'yy'-'mo'-'dd' 'STRIP( hh )':'mi

IF SYMBOL( 'build_date' ) <> 'VAR' THEN
DO
    PARSE VALUE DATE( 'O' ) WITH yyyy'/'mm'/'dd
    build_date = yyyy'-'mm'-'dd
    build_time = ' 'LEFT( TIME('N'), 5 )
END
build_date = ' 'STRIP( build_date )

build_host = VALUE( 'HOSTNAME',, 'OS2ENVIRONMENT' )
build_host = COPIES( ' ', 9 )||LEFT( build_host, MIN( LENGTH( build_host ), 11 ) )
build_language = TRANSLATE( LEFT( VALUE( 'LANG',, 'OS2ENVIRONMENT' ), 2 ) )
build_country = TRANSLATE( RIGHT( VALUE( 'LANG',, 'OS2ENVIRONMENT' ), 2 ) )
build_version = STRIP( STRIP( build_major,, D2C(9) ) )'.'STRIP( STRIP( build_minor,, D2C(9) ) )
IF LENGTH( STRIP( build_revision ) ) > 0 THEN
   build_version = build_version'.'STRIP( STRIP( build_revision,, D2C(9) ) )
build_build = STRIP( STRIP( build_build,, D2C(9) ) )
IF \DATATYPE( build_build, 'N' ) THEN
    build_build = ''
CALL CHAROUT , "Language specific application? ("build_language") (y/N) "
PARSE PULL answer
IF TRANSLATE( LEFT( answer, 1 ) ) = 'Y' THEN
DO
    CALL CHAROUT , "Only for use with Language? ("build_language" by default ) "
    PARSE PULL answer
    IF STRIP( answer ) <> '' THEN
        build_language = TRANSLATE( LEFT( answer, 2 ) )
END
ELSE build_language = ''
CALL CHAROUT , "Country specific application? ("build_country") (y/N) "
PARSE PULL answer
IF TRANSLATE( LEFT( answer, 1 ) ) = 'Y' THEN
DO
    CALL CHAROUT , "Only for use with Country? ("build_country" by default ) "
    PARSE PULL answer
    IF STRIP( answer ) <> '' THEN
        build_country = TRANSLATE( LEFT( answer, 2 ) )
END
    ELSE build_country = ''
CALL CHAROUT , "Require specific fixpak? (y/N)"
PARSE PULL answer
IF TRANSLATE( LEFT( answer, 1 ) ) = 'Y' THEN
DO
    CALL CHAROUT , "State the fixpak number required ( none by default ) "
    PARSE PULL answer
    IF STRIP( answer ) <> '' THEN
        build_fixpak = answer
END
ELSE build_fixpak = ''

'@del buildlevel.rc'
CALL LINEOUT 'buildlevel.rc', 'RCDATA 1 { "@#'build_vendor':'build_version'#@##1##'build_date||build_host':'build_feature':'build_language':'build_country':'build_build':'build_cpu':'build_fixpak'@@'build_description'" }'
CALL STREAM 'buildlevel.rc', 'C', 'CLOSE'

'@del version.h'
CALL LINEOUT 'version.h', '/*'
CALL LINEOUT 'version.h', ' * Filename: version.h'
CALL LINEOUT 'version.h', ' *   Author: 'build_vendor
CALL LINEOUT 'version.h', ' *  Created: 'STRIP( build_date )
CALL LINEOUT 'version.h', ' *  Purpose: 'build_description
CALL LINEOUT 'version.h', ' */'
CALL LINEOUT 'version.h', ''
CALL LINEOUT 'version.h', ' #define VER_MAJOR        'build_major
CALL LINEOUT 'version.h', ' #define VER_MINOR        'build_minor
CALL LINEOUT 'version.h', ' #define VER_REVISION     'build_revision
CALL LINEOUT 'version.h', ' #define VER_BUILD        'build_build
CALL LINEOUT 'version.h', ''
CALL LINEOUT 'version.h', ' #define APP_DATE        "'DATE()'"'
CALL LINEOUT 'version.h', ' #define APP_VENDOR      "'build_vendor'"'
CALL LINEOUT 'version.h', ' #define APP_EMAIL       "'build_email'"'
CALL LINEOUT 'version.h', ' #define APP_HOMEPAGE    "'build_homepage'"'
CALL LINEOUT 'version.h', ' #define APP_NAME        "'build_name'"'
CALL LINEOUT 'version.h', ' #define APP_DESCRIPTION "'build_description'"'
CALL STREAM 'version.h', 'C', 'CLOSE'

RETURN 0
